﻿class Flag extends MovieClip
{
	// ***** VARIABLES *****
	
	var myDate:Date;
	var stars:Array;
	var starCount:Number;
	
	// ***** CONSTRUCTOR *****
	
	public function Flag()
	{
		var STAR_ROWS = new Array(9,35,61,87,113,139,165,191,217);
		var STAR_COL_ODD = new Array(7, 59, 111, 163, 215, 267);
		var STAR_COL_EVEN = new Array(33,85,137,189,241);
		
		stars = new Array(50);
		var stindex:Number = 0;
		var cntrR:Number;
		var cntrC:Number;
		var lineArray:Array;
		for (cntrR= 0; cntrR < 9; ++cntrR)
		{
			if ((cntrR & 1) == 1) // remember count off by one
				lineArray = STAR_COL_EVEN;
			else
				lineArray = STAR_COL_ODD;
			for (cntrC = 0; cntrC < lineArray.length; ++cntrC)
			{
				stars[stindex] = attachMovie("star", "s"+stindex, stindex+1);
				stars[stindex]._x = lineArray[cntrC];
				stars[stindex]._y = STAR_ROWS[cntrR];
				stars[stindex]._visible = false;
				++stindex;
			}
		}
	}
	
	// ***** FUNCTIONS for controlling the game *****
	
	/*
	 * starts the game over by hiding and scrambling star order
	*/
	function restart()
	{
		var cntr:Number;
		var rnd:Number;
		var temp;
		
		starCount = 50;
		for (cntr = 0; cntr < 50; ++cntr)
		{
			stars[cntr]._visible = false;
		}
		for (cntr = 0; cntr < 50; ++cntr)
		{
			rnd = Math.floor(Math.random() * 50);
			temp = stars[cntr];
			stars[cntr] = stars[rnd];
			stars[rnd] = temp;
		}
		
		myDate = new Date();
	}
	
	/*
	* shows one of the flag's stars
	* Returns number of stars remaining
	*/
	function showStar():Number
	{
		trace("showStar() called");
		if (starCount > 0)
		{
			stars[50-starCount]._visible = true;
			--starCount;
			return starCount;
		}
		else
			return 0;
	}
	
	public function getScore():Number
	{
		var curDate:Date = new Date();
		var score:Number;
		score = 200000 - (curDate.getTime() - myDate.getTime());
		if (score < 0)
			score = 0;
		return score;
	}

}